"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default,
  waitForAxeResults: () => waitForAxeResults
});
module.exports = __toCommonJS(src_exports);

// src/matchers/toPassAxe/index.ts
var import_test4 = require("@playwright/test");

// src/utils/options.ts
var import_test = require("@playwright/test");
var import_merge_deep = __toESM(require("merge-deep"), 1);
function getOptions(options = {}) {
  const info = import_test.test.info();
  return (0, import_merge_deep.default)(info.project.use.axeOptions, options);
}

// src/matchers/toPassAxe/index.ts
var import_axe_reporter_html = __toESM(require("axe-reporter-html"), 1);

// src/utils/attachments.ts
var import_node_path = __toESM(require("path"), 1);
var import_promises = __toESM(require("fs/promises"), 1);
var import_test2 = require("@playwright/test");
async function attach(info, name, data) {
  const outPath = import_node_path.default.join(info.outputPath(), name);
  await import_promises.default.writeFile(outPath, data, "utf8");
  info.attachments.push({
    name,
    path: outPath,
    contentType: `application/${import_node_path.default.extname(name)}`
  });
}

// src/utils/locator.ts
function isLocator(value) {
  return value.constructor.name === "Locator";
}
function resolveLocator(handle) {
  return isLocator(handle) ? handle : handle.locator("body");
}

// src/utils/poll.ts
var import_test3 = require("@playwright/test");
function getTimeout(timeout) {
  return timeout ?? import_test3.test.info()?._expect?.timeout ?? 5e3;
}
async function poll(locator, timeout, predicate) {
  let result = null;
  let expired = false;
  const timer = setTimeout(() => {
    expired = true;
  }, getTimeout(timeout));
  try {
    while (true) {
      if (expired)
        return result;
      result = await predicate();
      if (expired || result.ok)
        return result;
      await locator.evaluate(
        () => new Promise((resolve2) => setTimeout(resolve2, 250))
      );
    }
  } catch (e) {
  } finally {
    clearTimeout(timer);
  }
  return result;
}

// src/utils/axe.ts
var import_node_fs = __toESM(require("fs"), 1);
var import_isomorphic_resolve = __toESM(require("isomorphic-resolve"), 1);
async function injectAxe(locator) {
  if (await locator.evaluate(() => !!window.axe?.run)) {
    return;
  }
  const filePath = (0, import_isomorphic_resolve.default)("axe-core/axe.min.js");
  const axe = await import_node_fs.default.promises.readFile(filePath, "utf-8");
  await locator.evaluate((_, axe2) => window.eval(axe2), axe);
}
function runAxe(locator, options = {}) {
  return locator.evaluate(
    (el, options2) => window.axe.run(el, options2),
    options
  );
}

// src/waitForAxeResults.ts
async function waitForAxeResults(handle, { timeout, ...options } = {}) {
  const opts = getOptions(options);
  const locator = resolveLocator(handle);
  await injectAxe(locator);
  return poll(locator, timeout, async () => {
    const results = await runAxe(locator, opts);
    return {
      ok: !results.violations.length,
      results
    };
  });
}

// src/matchers/toPassAxe/index.ts
var summarize = (violations) => violations.map((violation) => `${violation.id}(${violation.nodes.length})`).join(", ");
async function getResults(obj, options) {
  if (obj.violations) {
    const results = obj;
    return {
      results,
      ok: !results.violations.length
    };
  } else {
    return waitForAxeResults(obj, options);
  }
}
async function toPassAxe(obj, options = {}) {
  try {
    const { results, ok } = await getResults(obj, options);
    if (!ok) {
      const info = import_test4.test.info();
      const opts = getOptions(options);
      const html = await (0, import_axe_reporter_html.default)(results);
      const filename = opts.filename || "axe-report.html";
      await attach(info, filename, html);
    }
    return {
      pass: ok,
      message: () => {
        return this.utils.matcherHint("toPassAxe", void 0, void 0, this) + `

Expected: No violations
Received: ${results.violations.length} violations

Violations: ${summarize(results.violations)}`;
      }
    };
  } catch (err) {
    return {
      pass: false,
      message: () => err.message
    };
  }
}

// src/matchers/index.ts
var matchers_default = {
  toPassAxe
};

// src/index.ts
var src_default = matchers_default;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  waitForAxeResults
});
